--[[ Event Radar, first release. This plugin allows a pilot to mark someone as an event host; afterwards, specially formatted sector chat will update ER with a team list. Written by Luxen De'Mark, August 2020]]--


declare("EventRadar", EventRadar or {}) --not actually sure what this does, but some things seem to need it?
local ER_Running = "OFF" --don't mess with things if a host isnt defined or event isn't being participated in.
local ER_marked_host = "Incarnate" --get player name for listening
local ER_Teams = {} --list of player names on pilot's team
local ER_print = "ON"

local function ER_MarkHost(_, arg) --function to handle marking the host and activating the rest of the plugin
	if arg ~= nil then --only mark host if called correctly
		ER_marked_host = arg[1] --name -> host
		ER_Running = "ON" --activate the plugin
		print("\127FF8888" .. ER_marked_host .. " has been registered as host and the Event Radar has been initialized!")
	else --handle missing arg - the pilot is likely asking how to use the plugin
		print("Try using /ER")
	end
end

RegisterUserCommand('EventRadar', ER_MarkHost)

local function ER_MarkTargetHost() --if pilot is in sector, use /ERTarget to make your current target the host
	
	ER_marked_host = GetTargetInfo()
	ER_Running = "ON"
	print("\127FF8888" .. ER_marked_host .. " has been registered as host and the Event Radar has been initialized!")
	
end

RegisterUserCommand('ERTarget', ER_MarkTargetHost)

local function ER_Toggle(_, arg)
	if arg ~= nil then
		if arg[1] == "print" then
			if ER_print == "ON" then
				ER_print = "OFF"
			else
				ER_print = "ON"
			end
			print("EventRadar's chat readback has been toggled " .. ER_print)
		elseif arg[1] == "toggle" then
			if ER_Running == "OFF" then
				ER_Running = "ON"
			else
				ER_Running = "OFF"
			end
			print("Event Radar is " .. ER_Running)
		else
			print("/EventRadar <Pilot in quotes> : to set host")
			print("/ER toggle : change if EventRadar is running")
			print("/ER print : change if EventRadar spams to chat as well as scan info and target box color")
			print("/ERTarget : EventRadar will set the current target as listened host")
		end
	else
			print("/EventRadar <Pilot in quotes> : to set host")
			print("/ER toggle : change if EventRadar is running")
			print("/ER print : change if EventRadar spams to chat as well as scan info and target box color")
			print("/ERTarget : EventRadar will set the current target as listened host")
	end
end

RegisterUserCommand('ER', ER_Toggle)

--modify hud.scaninfo???
local function ER_ReadHost(eventname, arg)
	
	if ER_Running == "ON" then --is ER actually running
		if arg.name == ER_marked_host then --is the host the one who is speaking?
			local tempparse = arg.msg
			if string.sub(arg.msg, 1, 4) == "Team" then
				if string.find(tempparse, ":") then --make sure the message is a team list and not something else.
					local tempteam = {} --where all team members are stored after parsing
					local tempstringindex = string.find(tempparse, ":") --init index for iterator at the team declaration
					--local tempparsembr = string.sub(tempparse, tempstringindex + 1, -1) --not useful, stores the player list as a whole
					--local tempparseteam = string.sub(tempparse, 1, tempstringindex - 1) --not useful, stores the team name being reported
					while true do --iterate over all names seperated by ;
						local s = string.find(tempparse, ";", tempstringindex + 1) --find next index
						if s == nil then break end --if index doesnt exist, skip
						table.insert(tempteam, string.sub(tempparse, tempstringindex + 2, s - 1)) --add name between current and next index
						tempstringindex = s --next index becomes current
						
						
					end
					table.insert(tempteam, string.sub(tempparse, tempstringindex + 2, -1)) --add pilot at end of string to table
					
					--now check if the table contains the pilot's name; if not, the table is trashed
					local name = string.sub(GetPlayerName(), 1, 10) --TeamDX truncates names to 10 chars for space saving. 
					local keepteamlist = false --We only keep the team list if the pilot is in it. if pilot isnt in team, its an enemy.
					for key, value in pairs(tempteam) do --iterate over team members to find pilot
						if name == value then
							keepteamlist = true
							break
						end
					end
					if keepteamlist == true then
						ER_Teams = tempteam
						print("Player team updated")
					end
				end


			end
		end
	end
	
end

RegisterEvent(ER_ReadHost, "CHAT_MSG_SECTOR")


local function ER_MarkTarget() --test if your target is on your team or not
	if ER_Running == "ON" then --make sure the event is actually running
		local target = GetTargetInfo() --get target
		local onteam = false
		for key, value in pairs(ER_Teams) do --iterate team members, compare to target.
			if target == value then 
				onteam = true --found a match
				
				break
			end
		end
		if target ~= nil then
			if onteam == true then
				if ER_print == "ON" then
					print("\12788FF88" .. target .. " is a member of your team!")
				end
				HUD.scaninfo.title = HUD.scaninfo.title .. "\n\12788FF88Team member"
				radar.SetSelColor(255, 255, 255)
			else
				if ER_print == "ON" then
					print("\127FF0000" .. target .. " is NOT on your team, shoot him!")
				end
				HUD.scaninfo.title = HUD.scaninfo.title .. "\n\127FF0000Opposition"
				radar.SetSelColor(255, 000, 000)
			end
		end
	end
end

RegisterEvent(ER_MarkTarget, "TARGET_CHANGED")

















